/* -------------------------------------------- */
import { Misc } from "./misc.js";

const matchOperations = new RegExp(/@(\w*){([\w\-]+)}/ig);
const matchOperationTerms = new RegExp(/@(\w*){([\w\-]+)}/i);
/* -------------------------------------------- */
export class RdDAlchimie {

  /* -------------------------------------------- */
  static processManipulation(recetteData, actorId = undefined) {
    //console.log("CALLED", recette, recette.isOwned, actorId );
    let manip = recetteData.data.manipulation;
    let matchArray = manip.match(matchOperations);
    if (matchArray) {
      for (let matchStr of matchArray) {
        let result = matchStr.match(matchOperationTerms);
        //console.log("RESULT ", result);
        if (result[1] && result[2]) {
          let commande = Misc.upperFirst(result[1]);
          let replacement = this[`_alchimie${commande}`](recetteData, result[2], actorId);
          manip = manip.replace(result[0], replacement);
        }
      }
    }
    recetteData.data.manipulation_update = manip;
  }

  /* -------------------------------------------- */
  static _alchimieCouleur(recette, couleurs, actorId) {
    if (actorId) {
      return `<span class="alchimie-tache"><a data-recette-id="${recette._id}" data-actor-id="${actorId}" data-alchimie-tache="couleur" data-alchimie-data="${couleurs}">couleur ${couleurs}</a></span>`;
    } else {
      return `<span class="alchimie-tache">couleur ${couleurs} </span>`;
    }
  }

  /* -------------------------------------------- */
  static _alchimieConsistance(recette, consistances, actorId) {
    if (actorId) {
      return `<span class="alchimie-tache"><a data-recette-id="${recette._id}" data-actor-id="${actorId}" data-alchimie-tache="consistance" data-alchimie-data="${consistances}">consistance ${consistances}</a></span>`;
    } else {
      return `<span class="alchimie-tache">consistance ${consistances} </span>`;
    }
  }

  /* -------------------------------------------- */
  static getDifficulte( aspects ) {
    let aspectsArray = aspects.split('-');
    let diff = 0;
    let nbDifferent = 0;
    let aspectsHash = {}
    for (let colconst of aspectsArray) {
      if ( aspectsHash[colconst] ){  // Deja present, augmente difficulté de 1
        diff -= 1;
      } else {
        nbDifferent++;
        aspectsHash[colconst] = colconst; // Keep track
      }
    }
    diff = diff - ((nbDifferent>1) ? nbDifferent : 0); // Ca doit marcher ....
    return Math.min(0, diff); // Pour être sur
  }
}
